// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package track_events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/work/lib/api/members/members_models"
)

// NewPutTrackEventsParams creates a new PutTrackEventsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPutTrackEventsParams() *PutTrackEventsParams {
	return &PutTrackEventsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPutTrackEventsParamsWithTimeout creates a new PutTrackEventsParams object
// with the ability to set a timeout on a request.
func NewPutTrackEventsParamsWithTimeout(timeout time.Duration) *PutTrackEventsParams {
	return &PutTrackEventsParams{
		timeout: timeout,
	}
}

// NewPutTrackEventsParamsWithContext creates a new PutTrackEventsParams object
// with the ability to set a context for a request.
func NewPutTrackEventsParamsWithContext(ctx context.Context) *PutTrackEventsParams {
	return &PutTrackEventsParams{
		Context: ctx,
	}
}

// NewPutTrackEventsParamsWithHTTPClient creates a new PutTrackEventsParams object
// with the ability to set a custom HTTPClient for a request.
func NewPutTrackEventsParamsWithHTTPClient(client *http.Client) *PutTrackEventsParams {
	return &PutTrackEventsParams{
		HTTPClient: client,
	}
}

/*
PutTrackEventsParams contains all the parameters to send to the API endpoint

	for the put track events operation.

	Typically these are written to a http.Request.
*/
type PutTrackEventsParams struct {

	/* TrackeventRequest.

	   An array of new TrackEvent records
	*/
	TrackeventRequest *members_models.TrackEventRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the put track events params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutTrackEventsParams) WithDefaults() *PutTrackEventsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the put track events params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PutTrackEventsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the put track events params
func (o *PutTrackEventsParams) WithTimeout(timeout time.Duration) *PutTrackEventsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put track events params
func (o *PutTrackEventsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put track events params
func (o *PutTrackEventsParams) WithContext(ctx context.Context) *PutTrackEventsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put track events params
func (o *PutTrackEventsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put track events params
func (o *PutTrackEventsParams) WithHTTPClient(client *http.Client) *PutTrackEventsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put track events params
func (o *PutTrackEventsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithTrackeventRequest adds the trackeventRequest to the put track events params
func (o *PutTrackEventsParams) WithTrackeventRequest(trackeventRequest *members_models.TrackEventRequest) *PutTrackEventsParams {
	o.SetTrackeventRequest(trackeventRequest)
	return o
}

// SetTrackeventRequest adds the trackeventRequest to the put track events params
func (o *PutTrackEventsParams) SetTrackeventRequest(trackeventRequest *members_models.TrackEventRequest) {
	o.TrackeventRequest = trackeventRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PutTrackEventsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.TrackeventRequest != nil {
		if err := r.SetBodyParam(o.TrackeventRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
