// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package track_users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new track users API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for track users API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetTrackUsers(params *GetTrackUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTrackUsersOK, error)

	PostTrackUsers(params *PostTrackUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTrackUsersOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetTrackUsers gets a list track users

Return a list of TrackUser records from the datastore
*/
func (a *Client) GetTrackUsers(params *GetTrackUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTrackUsersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTrackUsersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTrackUsers",
		Method:             "GET",
		PathPattern:        "/trackusers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTrackUsersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTrackUsersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTrackUsers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostTrackUsers creates new track users

Create TrackUsers
*/
func (a *Client) PostTrackUsers(params *PostTrackUsersParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTrackUsersOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTrackUsersParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTrackUsers",
		Method:             "POST",
		PathPattern:        "/trackusers",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTrackUsersReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTrackUsersOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTrackUsers: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
