// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2023 by Vernon Keenan
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tracks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new tracks API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for tracks API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetTracks(params *GetTracksParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTracksOK, error)

	PostTracks(params *PostTracksParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTracksOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetTracks gets a list tracks

Return a list of Track records from the datastore
*/
func (a *Client) GetTracks(params *GetTracksParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetTracksOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTracksParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getTracks",
		Method:             "GET",
		PathPattern:        "/tracks",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTracksReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTracksOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTracks: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostTracks creates new tracks

Create Tracks
*/
func (a *Client) PostTracks(params *PostTracksParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostTracksOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTracksParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postTracks",
		Method:             "POST",
		PathPattern:        "/tracks",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTracksReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTracksOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTracks: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
